#!/usr/bin/perl5
#
# make match based Swiss-Rounds
#  copyright Atsushi Arakawa, 1999-2000

srand;
rand;

$opt = "";
while ($#ARGV >= 0 && $ARGV[0] =~ /^[\/\-]/ ) {
	$_ = shift;
	s/^.//;
	$opt .= $_;
}
die <<"EOT" if ($opt =~ /[^odg]/i);
usage: $0 [option] [file]
  -o  enable OMP sort (default:random)
  -d  enable Damage sort (default:random)
  -g  use damage he deals only (default:difference)
EOT

while (<>) {
	s/\s*([;#].*)?$//;
	if (/^(\d+)=\s*(.*)\s*$/) {
		$name[$1] = $2;
		$pts[$1] += 0;
		next;
	}
	split(/[\s:]/);
	next if (@_ == 0);
	($a, $da, $b, $db) = @_;
	$a0 = (($a > 0) ? $a : -$a) +0;
	$b0 = (($b > 0) ? $b : -$b) +0;
	if ($a>0 && $b>0) {
		die("unprocessed data\n");
	} elsif ($a>0) {
		$pts[$a0] += 3;
	} elsif ($b>0) {
		$pts[$b0] += 3;
	} else {
		$pts[$a0] ++;
		$pts[$b0] ++;
	}
	$op[$a0] .= "$b0 ";
	$op[$b0] .= "$a0 ";
	$dm_s[$a0] += $da;
	$dm_r[$a0] += $db;
	$dm_s[$b0] += $db;
	$dm_r[$b0] += $da;
}
$pts[0] = 0;

for ($i=0; $i<@op; ++$i) {
	$omp[$i] = 0;
	chop($op[$i]);
	foreach (split(/\s/, $op[$i])) {
		$omp[$i] += $pts[$_];
	}
	$rnd[$i] = rand;
}

@cpl = (reverse(sort by_rate (1..@pts-1)), 0);

$n = @cpl - (@cpl % 2);
($record_flg, $record_pts, @record_cpl) = (0, "");
&make_match(0, $n-1);
die("can't make match\n") if ($record_pts eq "");
@cpl = @record_cpl;

for ($i=0; $i<@pts-1; $i+=2) {
	($x, $y) = @cpl[$i, $i+1];
	@buf = (@buf, sprintf("%d%03d%03d %04d:0 %04d:0  ; %s(%d.%d:%d-%d)-%s(%d.%d:%d-%d)\n",
			($x!=0 && $y!=0), @pts[$x, $y], $x, $y,
			$name[$x], $pts[$x], $omp[$x], $dm_s[$x], $dm_r[$x],
			$name[$y], $pts[$y], $omp[$y], $dm_s[$y], $dm_r[$y]));
}

foreach (reverse(sort @buf)) {
	s/^\d+\s+//;
	print $_;
}

exit;

sub by_rate {
	$pts[$a] <=> $pts[$b] ||
	(($opt =~ /o/i) ? $omp[$a] <=> $omp[$b] : 0) ||
	(($opt =~ /d/i) ? (($opt =~ /g/i) ? $dm_s[$a] <=> $dm_s[$b] : $dm_s[$a]-$dm_r[$a] <=> $dm_s[$b]-$dm_r[$b]) : 0) ||
	$rnd[$a] <=> $rnd[$b];
}

sub ck_op {
	local($x, $y) = @_;
	local($flg) = 0;

	foreach (split(/\s/, $op[$x])) {
		if ($_ == $y) {
			$flg = 1;
			last;
		}
	}
	$flg;
}

sub make_match {
	local($s, $e) = @_;
	return &record_match if ($s >= $e);

	local($flg, @bk) = (0, @cpl);
	local($i);

	for ($i=$s+1; $i<=$e; ++$i) {
		@cpl[$s+1, $i] = @cpl[$i, $s+1];
		$record_flg |= ($pts[$cpl[$i]] != $pts[$cpl[$s+1]]);
		if (&ck_op(@cpl[$s,$s+1]) == 0) {
			last if (&make_match($s+2, $e) == 0);
		}
	}
	if ($i>$e) {
		$flg = 1;
		@cpl = @bk;
	}
	$flg;
}

sub record_match {
	local($pts);
	foreach (@cpl) {
		$pts .= sprintf("%03d", $pts[$_]);
	}
	($record_pts, @record_cpl) = ($pts, @cpl) if ($pts gt $record_pts);
	$record_flg;
}
