#!/usr/bin/perl5
#
# calucurate ranking based Swiss-Rounds
#  copyright Atsushi Arakawa, 1999-2000

$opt = "";
while ($#ARGV >= 0 && $ARGV[0] =~ /^[\/\-]/ ) {
	$_ = shift;
	s/^.//;
	$opt .= $_;
}
die <<"EOT" if ($opt =~ /[^dg]/i);
usage: $0 [option] [file]
  -d  precede Damage (default:OMP)
  -g  use damage he deals only (default:difference)
EOT

while (<>) {
	s/\s*([;#].*)?$//;
	if (/^(\d+)=\s*(.*)\s*$/) {
		$name[$1] = $2;
		$pts[$1] += 0;
		next;
	}
	split(/[\s:]/);
	next if (@_ == 0);
	($a, $da, $b, $db) = @_;
	$a0 = (($a > 0) ? $a : -$a) +0;
	$b0 = (($b > 0) ? $b : -$b) +0;
	if ($a>0 && $b>0) {
		die("unprocessed data\n");
	} elsif ($a>0) {
		$pts[$a0] += 3;
	} elsif ($b>0) {
		$pts[$b0] += 3;
	} else {
		$pts[$a0] ++;
		$pts[$b0] ++;
	}
	$op[$a0] .= "$b0 ";
	$op[$b0] .= "$a0 ";
	$dm_s[$a0] += $da;
	$dm_r[$a0] += $db;
	$dm_s[$b0] += $db;
	$dm_r[$b0] += $da;
}
$pts[0] = 0;

for ($i=0; $i<@op; ++$i) {
	$omp = 0;
	chop($op[$i]);
	foreach (split(/\s/, $op[$i])) {
		$omp += $pts[$_];
	}
	@pts2 = (@pts2, sprintf("%03d %03d %02d %02d %04d", $pts[$i], $omp, $dm_s[$i], $dm_r[$i], $i));
}

$i = $r = 0;
$b = "";
foreach (reverse(sort by_rank @pts2)) {
	++$i;
	$a = $_;
	$r = $i if (&by_rank != 0);
	split;
	printf("%3d:%04d (pts=%3d, omp=%3d, dmg=%2d-%2d=%+3d) ; %s\n",
		$r, @_[4,0,1,2,3], $_[2]-$_[3], $name[$_[4]]);
	$b = $_;
}

exit;

sub by_rank {
	local(@a) = split(/\s/, $a);
	local(@b) = split(/\s/, $b);
	local($da, $db) = ($opt =~ /g/i) ? ($a[2],$b[2]) : ($a[2]-$a[3], $b[2]-$b[3]);
	$a[0]<=>$b[0] || (($opt =~ /d/i) ? $da<=>$db : 0) || $a[1]<=>$b[1] || $da <=> $db;
}
